﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace ForGet
{
    public class MultipleSourceRepository : IPackageSource
    {
        readonly IPackageSource[] _packageSources;

        public MultipleSourceRepository(IEnumerable<IPackageSource> packageSources)
        {
            _packageSources = packageSources.ToArray();
        }

        public string DownloadPackage(string packageId, string version)
        {
            foreach(var repo in _packageSources)
            {
                string path = repo.DownloadPackage(packageId, version);
                if(path != null)
                {
                    return path;
                }
            }
            return null;
        }

        public IEnumerable<Version> GetVersions(string packageId)
        {
            foreach(var repo in _packageSources)
            {
                foreach (var version in repo.GetVersions(packageId))
                {
                    yield return version;
                }
            }
        }
    }
}
